import { Scikit1D, Scikit2D } from '../types';
/**
 * Validation helper to check if the test/test sizes are meaningful wrt to the
 * size of the data (n_samples)
 */
export declare function validateShuffleSplit(nSamples: number, testSize?: number, trainSize?: number, defaultTestSize?: number): number[];
export declare function getIndices(X: Scikit2D | Scikit1D, indices: number[]): any;
/**
 *
 * Helper function that can split training and testing data into different splits.
 * This helps with cross validation and model selection.
 *
 * @example
 * ```typescript
 * import {trainTestSplit} from 'scikitjs'
 *
 * let X = [[5, 6],[8,2],[3,4]]
 * let y = [10, 20, 30]
 *
 * let [XTrain, XTest, yTrain, yTest] = trainTestSplit(X, y, .3)
 * ```
 */
export declare function trainTestSplit(X: Scikit2D, y: Scikit1D, testSize?: number, trainSize?: number, randomState?: number): any[];
