/**
*  @license
* Copyright 2021, JsData. All rights reserved.
*
* This source code is licensed under the MIT license found in the
* LICENSE file in the root directory of this source tree.

* Unless required by applicable law or agreed to in writing, software
* distributed under the License is distributed on an "AS IS" BASIS,
* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
* See the License for the specific language governing permissions and
* limitations under the License.
* ==========================================================================
*/
import { Scikit1D } from '../types';
/**
 *
 * ```js
 *const labels = [1, 2, 3, 1]
  const predictions = [1, 2, 4, 4]
  let result = metrics.accuracyScore(labels, predictions)
  console.log(result) // 0.5
 *```
 * @param labels 1D Array-like that are the true values
 * @param predictions 1D Array-like that are your model predictions
 * @returns number
 */
export declare function accuracyScore(labels: Scikit1D, predictions: Scikit1D): number;
export declare function precisionScore(labels: Scikit1D, predictions: Scikit1D): any;
export declare function recallScore(labels: Scikit1D, predictions: Scikit1D): any;
export declare function r2Score(labels: Scikit1D, predictions: Scikit1D): any;
export declare function meanAbsoluteError(labels: Scikit1D, predictions: Scikit1D): number;
export declare function meanSquaredError(labels: Scikit1D, predictions: Scikit1D): any;
export declare function meanSquaredLogError(labels: Scikit1D, predictions: Scikit1D): any;
export declare function hingeLoss(labels: Scikit1D, predictions: Scikit1D): any;
export declare function huberLoss(labels: Scikit1D, predictions: Scikit1D): any;
export declare function logLoss(labels: Scikit1D, predictions: Scikit1D): any;
export declare function zeroOneLoss(labels: Scikit1D, predictions: Scikit1D): any;
export declare function confusionMatrix(labels: Scikit1D, predictions: Scikit1D): any;
export declare function rocAucScore(labels: Scikit1D, predictions: Scikit1D): number;
